#include <bits/stdc++.h>
using namespace std;
int m[2020][2020] ;

int pogodna( int k , int n )
{
    int brpon=0 , maksi=0 , maksj=0 , mini=2001 , minj=2001 ;
    for ( int i=0 ; i<n ; i++ )
    {
        for ( int j=0 ; j<n ; j++ )
        {
            if (m[i][j]==k)
            {
                brpon++ ;
                if ( i<mini ) {
                    mini=i ;
                }
                if ( j<minj ) {
                    minj=j ;
                }
                if ( i>maksi ) {
                    maksi=i ;
                }
                if ( j>maksj ) {
                    maksj=j ;
                }
            }
        }
    }
    for ( int i=mini ; i<=maksi ; i++ )
    {
        for ( int j=minj ; j<=maksj ; j++ )
        {
            if ( m[i][j]!=k )
            {
                return 0 ;
            }
        }
    }
    if ( brpon==0 )
    {
        return 0 ;
    }
    return 1 ;
}

int main()
{
    int n , k , brpog=0 ;
    cin >> n >> k ;
    for ( int i=0 ; i<n ; i++ )
    {
        for ( int j=0 ; j<n ; j++ )
        {
            cin >> m[i][j] ;
        }
    }
    for ( int i=1 ; i<=k ; i++ )
    {
        if ( pogodna(i,n)==1 )
        {
            brpog++ ;
        }
    }
    cout << brpog << endl ;
    return 0;
}